/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef _BSP_WIRE_H_
#define _BSP_WIRE_H_

#include "stm32.h"

#define TWI_BUFFER_LENGTH   32

class TwoWire
{
public:
    TwoWire();
    void begin(uint8_t address = 0);
    void end(void);
    void setClock(uint32_t);
    void beginTransmission(uint8_t);
    uint8_t endTransmission(uint8_t sendStop = true);
    uint8_t requestFrom(uint8_t address, uint8_t quantity, uint8_t sendStop = 1);
    size_t write(uint8_t);
    size_t write(const uint8_t *, size_t);
    int available(void);
    int read(void);
    int peek(void);
    void onReceive( void (*)(int) );
    void onRequest( void (*)(void) );
private:
        uint8_t m_error;
    uint8_t rxBuffer[TWI_BUFFER_LENGTH];
    uint8_t rxBufferIndex;
    uint8_t rxBufferLength;
    uint8_t txAddress;
    uint8_t txBuffer[TWI_BUFFER_LENGTH];
    uint8_t txBufferIndex;
    uint8_t txBufferLength;
    uint8_t transmitting;
    void (*user_onRequest)(void);
    void (*user_onReceive)(int);
};
extern TwoWire Wire;

#endif//_BSP_WIRE_H_
