/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef STM32_SOFT_I2C_MASTER_H
#define STM32_SOFT_I2C_MASTER_H

#include "stm32.h"

#if defined(_BUILD_BRD_STM32H745)
#define SDA_PORT		GPIOB
#define SDA_PIN			GPIO_PIN_9_IDX
#define SCL_PORT		GPIOB
#define SCL_PIN			GPIO_PIN_8_IDX
#else
#define SDA_PORT		GPIOF
#define SDA_PIN			GPIO_PIN_0_IDX
#define SCL_PORT		GPIOF
#define SCL_PIN			GPIO_PIN_1_IDX
#endif

#define I2C_MAXWAIT		5000

bool i2c_init(void);
void i2c_setFreq(uint32_t clk);
bool i2c_start(uint8_t addr);
bool i2c_start_wait(uint8_t addr);
bool i2c_rep_start(uint8_t addr);
void i2c_stop(void);
bool i2c_write(uint8_t value);
uint8_t i2c_read(bool last);

#endif//STM32_SOFT_I2C_MASTER_H
