/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef SIM_THW_IPC_H
#define SIM_THW_IPC_H

#include <stdio.h>
#include "sim_common_definitions.h"

////////////////////////////////////////////////////////shared memory///////////////////////////////////////////////////////
#ifndef SIM_STATIC_SHM_OFFSET
#define SIM_STATIC_SHM_OFFSET 0
#endif
#ifndef SIM_STATIC_SHM_SIZE
#define SIM_STATIC_SHM_SIZE 0
#endif
#define STATIC_SHM_SECS 32 //depends on platform
class StaticSharedMem
{
public:
    StaticSharedMem();
    ~StaticSharedMem();
    _BOOLEAN pre_allocate(_BYTE index, _UINT32 size, _BIT write_only);
    _BOOLEAN allocate(_BYTE index, _BIT write_only);
    _UINT32 write(_BYTE index, const _BYTE *data, _UINT32 size);
    _UINT32 read(_BYTE index, _BYTE *buff, _UINT32 read_size);
protected:
    volatile _BYTE* GetMemPtr(_BYTE index, _UINT32 size);
private:
    volatile _BYTE *m_shm_ref = (volatile _BYTE*)SIM_STATIC_SHM_OFFSET;
    _UINT32 m_sec_idxa[STATIC_SHM_SECS];
    _UINT32 m_sec_sizea[STATIC_SHM_SECS];
};
extern StaticSharedMem StaticShm;
////////////////////////////////////////////////////////////HSEM////////////////////////////////////////////////////////////
#define HSEM_OFFSET 16
#define HSEM_COUNT 16
class HwdSemaphore
{
public:
    HwdSemaphore();
    ~HwdSemaphore();
    _BOOLEAN lock(_BYTE hsem_idx, _BOOLEAN blocking);//hsem_idx starts from 0
    void unlock(_BYTE hsem_idx);
private:
};
extern HwdSemaphore HwdSem;

#endif//SIM_THW_IPC_H
